//
//  MODULE:   ntmfcdl.h
//
//  PURPOSE:
//    Contains declarations for use by Microsoft Foundation Class 
//    applications that are to use the OMS driver interface DLL,
//    NTDRV.DLL
//


#ifndef INC_OMSDLL_H
#define INC_OMSDLL_H

#include <windows.h>

//Axis selection constants
#define OMS_X_AXIS 0x01
#define OMS_Y_AXIS 0x02
#define OMS_Z_AXIS 0x04
#define OMS_T_AXIS 0x08
#define OMS_U_AXIS 0x10
#define OMS_V_AXIS 0x20
#define OMS_R_AXIS 0x40
#define OMS_S_AXIS 0x80

//Controller status flag defintions
#define  COMMAND_ERROR     0x01
#define  SLIP_ERROR        0x04
#define  OVERTRAVEL_ERROR  0x08


#define DLLIMPORT  extern "C" __declspec(dllimport)


DLLIMPORT HANDLE _stdcall GetOmsHandle (LPSTR);
DLLIMPORT void _stdcall CloseOmsHandle (HANDLE);
DLLIMPORT void _stdcall SendAndGetString (HANDLE, LPSTR, LPSTR);
DLLIMPORT long _stdcall SendString (HANDLE, LPSTR);
DLLIMPORT void _stdcall GetDoneFlags (HANDLE, LPBYTE);
DLLIMPORT void _stdcall GetStatusFlags (HANDLE, LPBYTE);
DLLIMPORT void _stdcall ClrDoneFlags (HANDLE, BYTE);
DLLIMPORT void _stdcall ClrStatusFlags (HANDLE, BYTE);
DLLIMPORT BOOL _stdcall ResetController (HANDLE);


#endif  // INC_OMSDLL_H
