/*++

Copyright (c) 1996  Oregon Micro Systems

Module Name:

    Task8.c

Abstract:

    Tests the OMS NT driver in a multi threaded enviroment.
    There are eigth threads each  one assigned to an axis.

Environment:

    user mode only


Revision History:

    06-12-96 : created
--*/



#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <winbase.h>
#include <winioctl.h>

//Define the OMS NT I/O control codes
#include "ntioctl.h"                                               
DWORD Thread1(DWORD dwThreadArg);
DWORD Thread2(DWORD dwThreadArg);
DWORD Thread3(DWORD dwThreadArg);
DWORD Thread4(DWORD dwThreadArg);
DWORD Thread5(DWORD dwThreadArg);
DWORD Thread6(DWORD dwThreadArg);
DWORD Thread7(DWORD dwThreadArg);
DWORD Thread8(DWORD dwThreadArg);



VOID
__cdecl
main(
    IN int   argc,
    IN char *argv[]
    )
/*++

Routine Description:

Arguments:

Return Value:

--*/
{
    char     completeDeviceName[64] = "\\\\.\\OMS0";
    int      Controller;
    DWORD dwThreadId1; 
    DWORD dwThread1Arg;
    HANDLE hThread1; 
    DWORD dwThreadId2; 
    DWORD dwThread2Arg;
    HANDLE hThread2; 
    DWORD dwThreadId3; 
    DWORD dwThread3Arg;
    HANDLE hThread3; 
    DWORD dwThreadId4; 
    DWORD dwThread4Arg;
    HANDLE hThread4; 
    DWORD dwThreadId5; 
    DWORD dwThread5Arg;
    HANDLE hThread5; 
    DWORD dwThreadId6; 
    DWORD dwThread6Arg;
    HANDLE hThread6; 
    DWORD dwThreadId7; 
    DWORD dwThread7Arg;
    HANDLE hThread7; 
    DWORD dwThreadId8; 
    DWORD dwThread8Arg;
    HANDLE hThread8; 
    DWORD  Status;
    
    int      Fields;
    int j;
    
    if(argc != 2)
    {
      printf("usage: task6 <controller Id number>\n");
      exit (1);
    }  

    //Get the motor controller number from the command line
    Fields = sscanf(argv[1], "%d",&Controller);
    if((Controller >= 0) && (Controller <=9))
    {
       //Include controller id number in the device name
       completeDeviceName[7] += (UCHAR)Controller;
    }   
    else
    {
       printf("Valid controller Id numbers are between 0 and 9\n");
       exit(1);
    }


    //Start up the thread to move the X axis                  
    hThread1 = CreateThread( 
        NULL,                        /* no security attributes        */ 
        0,                           /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) Thread1, /* thread function       */ 
        &dwThread1Arg,               /* argument to thread function   */ 
        0,                           /* use default creation flags    */ 
        &dwThreadId1);                /* returns the thread identifier */ 
    if (hThread1 == NULL) 
        printf("Thread 1 create error\n"); 
        
    //Start up the thread to move the Y axis                  
    hThread2 = CreateThread( 
        NULL,                            /* no security attributes        */ 
        0,                              /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) Thread2, /* thread function       */ 
        &dwThread2Arg,                  /* argument to thread function   */ 
        0,                              /* use default creation flags    */ 
        &dwThreadId2);                  /* returns the thread identifier */ 
    if (hThread2 == NULL) 
        printf("Thread 2 create error\n"); 
        
    //Start up the thread to move the Z axis                  
    hThread3 = CreateThread( 
        NULL,                            /* no security attributes        */ 
        0,                              /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) Thread3, /* thread function       */ 
        &dwThread3Arg,                  /* argument to thread function   */ 
        0,                              /* use default creation flags    */ 
        &dwThreadId3);                  /* returns the thread identifier */ 
    if (hThread3 == NULL) 
        printf("Thread 3 create error\n"); 
        
    //Start up the thread to move the t axis                  
    hThread4 = CreateThread( 
        NULL,                            /* no security attributes        */ 
        0,                              /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) Thread4, /* thread function       */ 
        &dwThread4Arg,                  /* argument to thread function   */ 
        0,                              /* use default creation flags    */ 
        &dwThreadId4);                  /* returns the thread identifier */ 
    if (hThread4 == NULL) 
        printf("Thread 4 create error\n"); 
        
    //Start up the thread to move the u axis                  
    hThread5 = CreateThread( 
        NULL,                            /* no security attributes        */ 
        0,                              /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) Thread5, /* thread function       */ 
        &dwThread5Arg,                  /* argument to thread function   */ 
        0,                              /* use default creation flags    */ 
        &dwThreadId5);                  /* returns the thread identifier */ 
    if (hThread5 == NULL) 
        printf("Thread 5 create error\n"); 
        
    //Start up the thread to move the v axis                  
    hThread6 = CreateThread( 
        NULL,                            /* no security attributes        */ 
        0,                              /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) Thread6, /* thread function       */ 
        &dwThread6Arg,                  /* argument to thread function   */ 
        0,                              /* use default creation flags    */ 
        &dwThreadId6);                  /* returns the thread identifier */ 
    if (hThread6 == NULL) 
        printf("Thread 6 create error\n"); 
        
        
    //Start up the thread to move the r axis                  
    hThread7 = CreateThread( 
        NULL,                            /* no security attributes        */ 
        0,                              /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) Thread7, /* thread function       */ 
        &dwThread7Arg,                  /* argument to thread function   */ 
        0,                              /* use default creation flags    */ 
        &dwThreadId7);                  /* returns the thread identifier */ 
    if (hThread7 == NULL) 
        printf("Thread 7 create error\n"); 
        
        
    //Start up the thread to move the s axis                  
    hThread8 = CreateThread( 
        NULL,                            /* no security attributes        */ 
        0,                              /* use default stack size        */ 
        (LPTHREAD_START_ROUTINE) Thread8, /* thread function       */ 
        &dwThread8Arg,                  /* argument to thread function   */ 
        0,                              /* use default creation flags    */ 
        &dwThreadId8);                  /* returns the thread identifier */ 
    if (hThread8 == NULL) 
        printf("Thread 8 create error\n"); 
        
      
    //Wait for all threads to complete
    //Time out after 50 seconds
    Status = WaitForSingleObject(hThread8, 50L*1000L);
    Status = WaitForSingleObject(hThread7, 50L*1000L);
    Status = WaitForSingleObject(hThread6, 50L*1000L);
    Status = WaitForSingleObject(hThread5, 50L*1000L);
    Status = WaitForSingleObject(hThread4, 50L*1000L);
    Status = WaitForSingleObject(hThread3, 50L*1000L);
    Status = WaitForSingleObject(hThread2, 50L*1000L);
    Status = WaitForSingleObject(hThread1, 50L*1000L);
    
    CloseHandle (hThread1);
    CloseHandle (hThread2);
    CloseHandle (hThread3);
    CloseHandle (hThread4);
    CloseHandle (hThread5);
    CloseHandle (hThread6);
    CloseHandle (hThread7);
    CloseHandle (hThread8);
    
    
}

//Thread to:
// - move the X axis 200 times
// - wait for each move to complete
// - report the axis position after each move
DWORD Thread1(DWORD dwThreadArg)
{  

    HANDLE   hDevice;
    BOOLEAN  Status;
    char     ResponseString[128];
    DWORD    BytesReturned;
    UCHAR    DoneFlags;
    UCHAR    DoneMask;
    UCHAR    StatusFlags;
    UCHAR    FlagMask;
    UCHAR    CommandCharsSent;
    int      Fields;
    int      Controller;
    int      i;
    DWORD    MStatus;

     //Get a handle to the motor controller's device driver OMS...
    hDevice = CreateFile ("\\\\.\\OMS1",
                          GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ | FILE_SHARE_WRITE,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL
                          );

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf ("Thread 1 Can't get a handle to \\\\.\\OMS1\n" );
        ExitThread(1);   
    }
    else
    {
        printf ("Thread 1 Start\n");
    }
    


   //Select an axis & set it's position
    Status = DeviceIoControl(
                             hDevice,
                             (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                       //don't expect a response
                             "ax lp1000;",                //Command string
                             (DWORD)128,               //Max length of string
                             &CommandCharsSent,        //Returns count of
                                                       // command chars sent
                             (DWORD)1,                 //...
                             &BytesReturned,          
                              NULL);                   //Synchronous Operations

    //If the controller did not accept all of the command string
    //with in two seconds clean up and exit the thread
    if(CommandCharsSent != 10)
    {
      printf("Thread 1 lp0 command timed out\n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 1 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
    //Give the controller some time to execute the previous command
    Sleep(100L);  
                                
                              
    //Send an axis position query to oms1 and wait for the response
    Status = DeviceIoControl(
                             hDevice,               //CreateFile Device handle
                             (DWORD)IOCTL_OMS_QUERY,//Send command get response
                             "ax rp;",              //Command string to send
                             (DWORD)128,            //Maximum length of command
                             (LPVOID)ResponseString,//Controller response here
                             (DWORD)128,            //Maximum length response
                             &BytesReturned,        //Actual length of response
                                                    //including the null.
                              NULL);                //Synchronous Operations 
    
    //If the controller returned the axis position with in 2 seconds                          
    if(ResponseString[0] != (UCHAR)NULL)
    {
      printf("Start Position X = %s \n", ResponseString);
    }
    else //handle the controller's response time out
    {
      printf("***Thread 1 position query time out \n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 1 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
                              
    //Command the axis to make 200 separate moves                          
    for (i=0; i<200; i++)
    {
      //Make sure the driver's copy of the axis done flag is clear                          
      DoneMask = 0x01;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                          
      //Send a move command:
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                         //don't expect a response
                               "ax mr1000;gd id",  //Command string
                               (DWORD)128,               //Max length of string
                               &CommandCharsSent,  //Returns cmd length
                               (DWORD)1,                  //...
                               &BytesReturned,          
                                NULL);                   //Synchronous Operations

      //If controller did not accept all of the command string with in 2
      // seconds then clean up and exit the thread
      if(CommandCharsSent != 15)
      {
        printf(" Thread 1 Command chars sent = %d \n",CommandCharsSent);
        printf(" Thread 1 mr1000... timed out\n");
        CloseHandle (hDevice);
        ExitThread(1);   
      }    
      
                              
      //Wait until the axis move is complete
      DoneFlags = 0;
      while ((DoneFlags & 0x01) != 0x01)
      {                          
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_DONE,//Read the driver's 
                                                            //copy of the done flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &DoneFlags,                //Done flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
      }                          
    
      //Clear the axis done bit in the drivers copy of the done flags                          
      DoneMask = 0x01;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                          
      //Get the current position of the axis
      //Send the command string "RP" to oms1 and wait for the response
      Status = DeviceIoControl(
                               hDevice,               //CreateFile Device handle
                               (DWORD)IOCTL_OMS_QUERY,//Send command get response
                               "ax rp",                  //Command string to send
                               (DWORD)128,            //Maximum length of command
                               (LPVOID)ResponseString,//Controller response here
                               (DWORD)128,            //Maximum length response
                               &BytesReturned,        //Actual length of response
                                                      //including the null.
                                NULL);                //Synchronous Operations 
                              
      if(ResponseString[0] == (UCHAR)NULL)
      {
        printf("***Thread 1 response time out \n");
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                              //copy of the status flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &StatusFlags,              //Status flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
        //Make sure the driver's copy of status flags are clear                          
        FlagMask = 0xff;
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                                 &FlagMask,                 //Flags selected by ones
                                 (DWORD) 1,                 //Mask is one byte
                                 (LPVOID)NULL,              //No response expected
                                 (DWORD) 0,                 //...
                                 &BytesReturned,            //Not used but required
                                  NULL);                    //Synchronous Operations
        printf("Thread 1 status flags = %0x \n", StatusFlags);                        
        CloseHandle (hDevice);
        ExitThread(0);   
      }    
                              
    }             
    
    printf("End Position X = %s \n", ResponseString);
    printf("Thread 1 done \n");
    //Wait 1 seond for printf to finish before exiting thread
    Sleep(1000L);
    
    //Close the motor controller's device handle
    CloseHandle (hDevice);
    
}


//Thread to:
// - move the Y axis 200 times
// - wait for each move to complete
// - report the axis position after each move
DWORD Thread2(DWORD dwThreadArg)
{  

    HANDLE   hDevice;
    BOOLEAN  Status;
    char     ResponseString[128];
    DWORD    BytesReturned;
    UCHAR    DoneFlags;
    UCHAR    DoneMask;
    UCHAR    StatusFlags;
    UCHAR    FlagMask;
    UCHAR    CommandCharsSent;
    int      Fields;
    int      Controller;
    int      i;
    DWORD    MStatus;

     //Get a handle to the motor controller's device driver OMS...
    hDevice = CreateFile ("\\\\.\\OMS1",
                          GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ | FILE_SHARE_WRITE,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL
                          );

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf ("Thread 2 Can't get a handle to \\\\.\\OMS1\n" );
        ExitThread(1);   
    }
    else
    {
        printf ("Thread 2 Start\n");
    }
    

   //Select an axis & set it's position
    Status = DeviceIoControl(
                             hDevice,
                             (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                       //don't expect a response
                             "ay lp2000;",                //Command string
                             (DWORD)128,               //Max length of string
                             &CommandCharsSent,        //Returns count of
                                                       // command chars sent
                             (DWORD)1,                 //...
                             &BytesReturned,          
                              NULL);                   //Synchronous Operations

    //If the controller did not accept all of the command string
    //with in two seconds clean up and exit the thread
    if(CommandCharsSent != 10)
    {
      printf("Thread 2 lp0 command timed out\n");
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
      
    //Give the controller some time to execute the previous command
    Sleep(100L);  
                                
                              
    //Send an axis position query to oms1 and wait for the response
    Status = DeviceIoControl(
                             hDevice,               //CreateFile Device handle
                             (DWORD)IOCTL_OMS_QUERY,//Send command get response
                             "ay rp;",              //Command string to send
                             (DWORD)128,            //Maximum length of command
                             (LPVOID)ResponseString,//Controller response here
                             (DWORD)128,            //Maximum length response
                             &BytesReturned,        //Actual length of response
                                                    //including the null.
                              NULL);                //Synchronous Operations 
                              
    //If the controller returned the axis position with in 2 seconds                          
    if(ResponseString[0] != (UCHAR)NULL)
    {
      printf("Start Position Y = %s \n", ResponseString);
    }
    else //handle the controller's response time out
    {
      printf("***Thread 2 position query time out \n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 2 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
                              
    //Command the axis to make 200 separate moves                          
    for (i=0; i<200; i++)
    {
      //Make sure the driver's copy of the axis done flag is clear                          
      DoneMask = 0x02;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                              
      //Send a move command:
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                         //don't expect a response
                               "ay mr1000;gd id",  //Command string
                               (DWORD)128,               //Max length of string
                               &CommandCharsSent,  //Returns cmd length
                               (DWORD)1,                  //...
                               &BytesReturned,          
                                NULL);                   //Synchronous Operations
    
      //If controller did not accept all of the command string with in 2
      // seconds then clean up and exit the thread
      if(CommandCharsSent != 15)
      {
        printf(" Thread 2 Command chars sent = %d \n",CommandCharsSent);
        printf(" Thread 2 mr1000... timed out\n");
        CloseHandle (hDevice);
        ExitThread(1);   
      }    
      
                              
      //Wait until the axis move is complete
      DoneFlags = 0;
      while ((DoneFlags & 0x02) != 0x02)
      {                          
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_DONE,//Read the driver's 
                                                            //copy of the done flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &DoneFlags,                //Done flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
      }                          
    
      //Clear the axis done bit in the drivers copy of the done flags                          
      DoneMask = 0x02;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                                
      //Get the current position of the axis
      //Send the command string "RP" to oms1 and wait for the response
      Status = DeviceIoControl(
                               hDevice,               //CreateFile Device handle
                               (DWORD)IOCTL_OMS_QUERY,//Send command get response
                               "ay rp",                  //Command string to send
                               (DWORD)128,            //Maximum length of command
                               (LPVOID)ResponseString,//Controller response here
                               (DWORD)128,            //Maximum length response
                               &BytesReturned,        //Actual length of response
                                                      //including the null.
                                NULL);                //Synchronous Operations 
                                
      if(ResponseString[0] == (UCHAR)NULL)
      {
        printf("***Thread 2 response time out \n");
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                              //copy of the status flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &StatusFlags,              //Status flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
        //Make sure the driver's copy of status flags are clear                          
        FlagMask = 0xff;
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                                 &FlagMask,                 //Flags selected by ones
                                 (DWORD) 1,                 //Mask is one byte
                                 (LPVOID)NULL,              //No response expected
                                 (DWORD) 0,                 //...
                                 &BytesReturned,            //Not used but required
                                  NULL);                    //Synchronous Operations
                                  
        printf("Thread 2 status flags = %0x \n", StatusFlags);                        
        CloseHandle (hDevice);
        ExitThread(0);   
      }    
                              
    }             
    printf("End Position Y = %s \n", ResponseString);
    printf("Thread 2 done \n");
    
    //Wait 1 second for printf to complete
    Sleep(1000L);
    
    //Close the motor controller's device handle
    CloseHandle (hDevice);
    
   
}


//Thread to:
// - move the Z axis 200 times
// - wait for each move to complete
// - report the axis position after each move
DWORD Thread3(DWORD dwThreadArg)
{  

    HANDLE   hDevice;
    BOOLEAN  Status;
    char     ResponseString[128];
    DWORD    BytesReturned;
    UCHAR    DoneFlags;
    UCHAR    DoneMask;
    UCHAR    StatusFlags;
    UCHAR    FlagMask;
    UCHAR    CommandCharsSent;
    int      Fields;
    int      Controller;
    int      i;
    DWORD    MStatus;

     //Get a handle to the motor controller's device driver OMS...
    hDevice = CreateFile ("\\\\.\\OMS1",
                          GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ | FILE_SHARE_WRITE,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL
                          );

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf ("Thread 3 Can't get a handle to \\\\.\\OMS1\n" );
        ExitThread(1);   
    }
    else
    {
        printf ("Thread 3 Start\n");
    }
    

   //Select an axis & set it's position
    Status = DeviceIoControl(
                             hDevice,
                             (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                       //don't expect a response
                             "az lp3000;",                //Command string
                             (DWORD)128,               //Max length of string
                             &CommandCharsSent,        //Returns count of
                                                       // command chars sent
                             (DWORD)1,                 //...
                             &BytesReturned,          
                              NULL);                   //Synchronous Operations

    //If the controller did not accept all of the command string
    //with in two seconds clean up and exit the thread
    if(CommandCharsSent != 10)
    {
      printf("Thread 3 lp0 command timed out\n");
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
    //Give the controller some time to execute the previous command
    Sleep(100L);  
      
                                
                              
    //Send an axis position query to oms1 and wait for the response
    Status = DeviceIoControl(
                             hDevice,               //CreateFile Device handle
                             (DWORD)IOCTL_OMS_QUERY,//Send command get response
                             "az rp;",              //Command string to send
                             (DWORD)128,            //Maximum length of command
                             (LPVOID)ResponseString,//Controller response here
                             (DWORD)128,            //Maximum length response
                             &BytesReturned,        //Actual length of response
                                                    //including the null.
                              NULL);                //Synchronous Operations 
                              
    //If the controller returned the axis position with in 2 seconds                          
    if(ResponseString[0] != (UCHAR)NULL)
    {
      printf("Start Position Z = %s \n", ResponseString);
    }
    else //handle the controller's response time out
    {
      printf("***Thread 3 position query time out \n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 3 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
                              
    //Command the axis to make 200 separate moves                          
    for (i=0; i<200; i++)
    {
      //Make sure the driver's copy of the axis done flag is clear                          
      DoneMask = 0x04;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                              
      //Send a move command:
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                         //don't expect a response
                               "az mr1000;gd id",  //Command string
                               (DWORD)128,               //Max length of string
                               &CommandCharsSent,  //Returns cmd length
                               (DWORD)1,                  //...
                               &BytesReturned,          
                                NULL);                   //Synchronous Operations
    
      //If controller did not accept all of the command string with in 2
      // seconds then clean up and exit the thread
      if(CommandCharsSent != 15)
      {
        printf(" Thread 3 Command chars sent = %d \n",CommandCharsSent);
        printf(" Thread 3 mr1000... timed out\n");
        CloseHandle (hDevice);
        ExitThread(1);   
      }    
      
                              
      //Wait until the axis move is complete
      DoneFlags = 0;
      while ((DoneFlags & 0x04) != 0x04)
      {                          
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_DONE,//Read the driver's 
                                                            //copy of the done flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &DoneFlags,                //Done flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
      }                          
    
      //Clear the axis done bit in the drivers copy of the done flags                          
      DoneMask = 0x04;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                                
      //Get the current position of the axis
      //Send the command string "RP" to oms1 and wait for the response
      Status = DeviceIoControl(
                               hDevice,               //CreateFile Device handle
                               (DWORD)IOCTL_OMS_QUERY,//Send command get response
                               "az rp",                  //Command string to send
                               (DWORD)128,            //Maximum length of command
                               (LPVOID)ResponseString,//Controller response here
                               (DWORD)128,            //Maximum length response
                               &BytesReturned,        //Actual length of response
                                                      //including the null.
                                NULL);                //Synchronous Operations 
                                
      if(ResponseString[0] == (UCHAR)NULL)
      {
        printf("***Thread 3 response time out \n");
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                              //copy of the status flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &StatusFlags,              //Status flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
        //Make sure the driver's copy of status flags are clear                          
        FlagMask = 0xff;
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                                 &FlagMask,                 //Flags selected by ones
                                 (DWORD) 1,                 //Mask is one byte
                                 (LPVOID)NULL,              //No response expected
                                 (DWORD) 0,                 //...
                                 &BytesReturned,            //Not used but required
                                  NULL);                    //Synchronous Operations
        printf("Thread 3 status flags = %0x \n", StatusFlags);                        
        CloseHandle (hDevice);
        ExitThread(0);   
      }    
                              
    }             
    
    printf("End Position Z = %s \n", ResponseString);
    printf("Thread 3 done \n");
    //Wait 1 second for printf to complete
    Sleep(1000);
    
    //Close the motor controller's device handle
    CloseHandle (hDevice);
    
   
}


//Thread to:
// - move the T axis 200 times
// - wait for each move to complete
// - report the axis position after each move
DWORD Thread4(DWORD dwThreadArg)
{  

    HANDLE   hDevice;
    BOOLEAN  Status;
    char     ResponseString[128];
    DWORD    BytesReturned;
    UCHAR    DoneFlags;
    UCHAR    DoneMask;
    UCHAR    StatusFlags;
    UCHAR    FlagMask;
    UCHAR    CommandCharsSent;
    int      Fields;
    int      Controller;
    int      i;
    DWORD    MStatus;

     //Get a handle to the motor controller's device driver OMS...
    hDevice = CreateFile ("\\\\.\\OMS1",
                          GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ | FILE_SHARE_WRITE,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL
                          );

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf ("Thread 4 Can't get a handle to \\\\.\\OMS1\n" );
        ExitThread(1);   
    }
    else
    {
        printf ("Thread 4 Start\n");
    }
    

   //Select an axis & set it's position
    Status = DeviceIoControl(
                             hDevice,
                             (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                       //don't expect a response
                             "at lp4000;",                //Command string
                             (DWORD)128,               //Max length of string
                             &CommandCharsSent,        //Returns count of
                                                       // command chars sent
                             (DWORD)1,                 //...
                             &BytesReturned,          
                              NULL);                   //Synchronous Operations

    //If the controller did not accept all of the command string
    //with in two seconds clean up and exit the thread
    if(CommandCharsSent != 10)
    {
      printf("Thread 4 lp0 command timed out\n");
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
    //Give the controller some time to execute the previous command
    Sleep(100L);  
      
                                
                              
    //Send an axis position query to oms1 and wait for the response
    Status = DeviceIoControl(
                             hDevice,               //CreateFile Device handle
                             (DWORD)IOCTL_OMS_QUERY,//Send command get response
                             "at rp;",              //Command string to send
                             (DWORD)128,            //Maximum length of command
                             (LPVOID)ResponseString,//Controller response here
                             (DWORD)128,            //Maximum length response
                             &BytesReturned,        //Actual length of response
                                                    //including the null.
                              NULL);                //Synchronous Operations 
                              
    //If the controller returned the axis position with in 2 seconds                          
    if(ResponseString[0] != (UCHAR)NULL)
    {
      printf("Start Position T = %s \n", ResponseString);
    }
    else //handle the controller's response time out
    {
      printf("***Thread 4 position query time out \n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 4 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
                              
    //Command the axis to make 200 separate moves                          
    for (i=0; i<200; i++)
    {
      //Make sure the driver's copy of the axis done flag is clear                          
      DoneMask = 0x08;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                              
      //Send a move command:
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                         //don't expect a response
                               "at mr1000;gd id",  //Command string
                               (DWORD)128,               //Max length of string
                               &CommandCharsSent,  //Returns cmd length
                               (DWORD)1,                  //...
                               &BytesReturned,          
                                NULL);                   //Synchronous Operations
    
      //If controller did not accept all of the command string with in 2
      // seconds then clean up and exit the thread
      if(CommandCharsSent != 15)
      {
        printf(" Thread 4 Command chars sent = %d \n",CommandCharsSent);
        printf(" Thread 4 mr1000... timed out\n");
        CloseHandle (hDevice);
        ExitThread(1);   
      }    
      
                              
      //Wait until the axis move is complete
      DoneFlags = 0;
      while ((DoneFlags & 0x08) != 0x08)
      {                          
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_DONE,//Read the driver's 
                                                            //copy of the done flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &DoneFlags,                //Done flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
      }                          
    
      //Clear the axis done bit in the drivers copy of the done flags                          
      DoneMask = 0x08;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                                
      //Get the current position of the axis
      //Send the command string "RP" to oms1 and wait for the response
      Status = DeviceIoControl(
                               hDevice,               //CreateFile Device handle
                               (DWORD)IOCTL_OMS_QUERY,//Send command get response
                               "at rp",                  //Command string to send
                               (DWORD)128,            //Maximum length of command
                               (LPVOID)ResponseString,//Controller response here
                               (DWORD)128,            //Maximum length response
                               &BytesReturned,        //Actual length of response
                                                      //including the null.
                                NULL);                //Synchronous Operations 
                                
                                
      if(ResponseString[0] == (UCHAR)NULL)
      {
        printf("***Thread 4 response time out \n");
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                              //copy of the status flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &StatusFlags,              //Status flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
        //Make sure the driver's copy of status flags are clear                          
        FlagMask = 0xff;
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                                 &FlagMask,                 //Flags selected by ones
                                 (DWORD) 1,                 //Mask is one byte
                                 (LPVOID)NULL,              //No response expected
                                 (DWORD) 0,                 //...
                                 &BytesReturned,            //Not used but required
                                  NULL);                    //Synchronous Operations
        printf("Thread 4 status flags = %0x \n", StatusFlags);                        
        CloseHandle (hDevice);
        ExitThread(0);   
      }    
                              
    }             
    
    printf("End Position T = %s \n", ResponseString);
    printf("Thread 4 done \n");
    //Wait 1 second for printf to complete
    Sleep(1000L);
    
    //Close the motor controller's device handle
    CloseHandle (hDevice);
    
   
}

//Thread to:
// - move the U axis 200 times
// - wait for each move to complete
// - report the axis position after each move
DWORD Thread5(DWORD dwThreadArg)
{  

    HANDLE   hDevice;
    BOOLEAN  Status;
    char     ResponseString[128];
    DWORD    BytesReturned;
    UCHAR    DoneFlags;
    UCHAR    DoneMask;
    UCHAR    StatusFlags;
    UCHAR    FlagMask;
    UCHAR    CommandCharsSent;
    int      Fields;
    int      Controller;
    int      i;
    DWORD    MStatus;

     //Get a handle to the motor controller's device driver OMS...
    hDevice = CreateFile ("\\\\.\\OMS1",
                          GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ | FILE_SHARE_WRITE,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL
                          );

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf ("Thread 5 Can't get a handle to \\\\.\\OMS1\n" );
        ExitThread(1);   
    }
    else
    {
        printf ("Thread 5 Start\n");
    }
    

   //Select an axis & set it's position
    Status = DeviceIoControl(
                             hDevice,
                             (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                       //don't expect a response
                             "au lp5000;",                //Command string
                             (DWORD)128,               //Max length of string
                             &CommandCharsSent,        //Returns count of
                                                       // command chars sent
                             (DWORD)1,                 //...
                             &BytesReturned,          
                              NULL);                   //Synchronous Operations

    //If the controller did not accept all of the command string
    //with in two seconds clean up and exit the thread
    if(CommandCharsSent != 10)
    {
      printf("Thread 5 lp0 command timed out\n");
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
    //Give the controller some time to execute the previous command
    Sleep(100L);  
      
                                
                              
    //Send an axis position query to oms1 and wait for the response
    Status = DeviceIoControl(
                             hDevice,               //CreateFile Device handle
                             (DWORD)IOCTL_OMS_QUERY,//Send command get response
                             "au rp;",              //Command string to send
                             (DWORD)128,            //Maximum length of command
                             (LPVOID)ResponseString,//Controller response here
                             (DWORD)128,            //Maximum length response
                             &BytesReturned,        //Actual length of response
                                                    //including the null.
                              NULL);                //Synchronous Operations 
                              
    //If the controller returned the axis position with in 2 seconds                          
    if(ResponseString[0] != (UCHAR)NULL)
    {
      printf("Start Position U = %s \n", ResponseString);
    }
    else //handle the controller's response time out
    {
      printf("***Thread 5 position query time out \n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 5 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
                              
    //Command the axis to make 200 separate moves                          
    for (i=0; i<200; i++)
    {
      //Make sure the driver's copy of the axis done flag is clear                          
      DoneMask = 0x10;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                              
      //Send a move command:
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                         //don't expect a response
                               "au mr1000;gd id",  //Command string
                               (DWORD)128,               //Max length of string
                               &CommandCharsSent,  //Returns cmd length
                               (DWORD)1,                  //...
                               &BytesReturned,          
                                NULL);                   //Synchronous Operations
    
      //If controller did not accept all of the command string with in 2
      // seconds then clean up and exit the thread
      if(CommandCharsSent != 15)
      {
        printf(" Thread 5 Command chars sent = %d \n",CommandCharsSent);
        printf(" Thread 5 mr1000... timed out\n");
        CloseHandle (hDevice);
        ExitThread(1);   
      }    
      
                              
      //Wait until the axis move is complete
      DoneFlags = 0;
      while ((DoneFlags & 0x10) != 0x10)
      {                          
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_DONE,//Read the driver's 
                                                            //copy of the done flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &DoneFlags,                //Done flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
      }                          
    
      //Clear the axis done bit in the drivers copy of the done flags                          
      DoneMask = 0x10;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                                
      //Get the current position of the axis
      //Send the command string "RP" to oms1 and wait for the response
      Status = DeviceIoControl(
                               hDevice,               //CreateFile Device handle
                               (DWORD)IOCTL_OMS_QUERY,//Send command get response
                               "au rp",                  //Command string to send
                               (DWORD)128,            //Maximum length of command
                               (LPVOID)ResponseString,//Controller response here
                               (DWORD)128,            //Maximum length response
                               &BytesReturned,        //Actual length of response
                                                      //including the null.
                                NULL);                //Synchronous Operations 
                                
      if(ResponseString[0] == (UCHAR)NULL)
      {
        printf("***Thread 5 response time out \n");
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                              //copy of the status flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &StatusFlags,              //Status flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
        //Make sure the driver's copy of status flags are clear                          
        FlagMask = 0xff;
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                                 &FlagMask,                 //Flags selected by ones
                                 (DWORD) 1,                 //Mask is one byte
                                 (LPVOID)NULL,              //No response expected
                                 (DWORD) 0,                 //...
                                 &BytesReturned,            //Not used but required
                                  NULL);                    //Synchronous Operations
        printf("Thread 5 status flags = %0x \n", StatusFlags);                        
        CloseHandle (hDevice);
        ExitThread(0);   
      }    
                              
    }             
    
    printf("End Position U = %s \n", ResponseString);
    printf("Thread 5 done \n");
    //Wait 1 second for printf to complete
    Sleep(1000L);
    //Close the motor controller's device handle
    CloseHandle (hDevice);
    
   
}

//Thread to:
// - move the V axis 200 times
// - wait for each move to complete
// - report the axis position after each move
DWORD Thread6(DWORD dwThreadArg)
{  

    HANDLE   hDevice;
    BOOLEAN  Status;
    char     ResponseString[128];
    DWORD    BytesReturned;
    UCHAR    DoneFlags;
    UCHAR    DoneMask;
    UCHAR    StatusFlags;
    UCHAR    FlagMask;
    UCHAR    CommandCharsSent;
    int      Fields;
    int      Controller;
    int      i;
    DWORD    MStatus;

     //Get a handle to the motor controller's device driver OMS...
    hDevice = CreateFile ("\\\\.\\OMS1",
                          GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ | FILE_SHARE_WRITE,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL
                          );

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf ("Thread 6 Can't get a handle to \\\\.\\OMS1\n" );
        ExitThread(1);   
    }
    else
    {
        printf ("Thread 6 Start\n");
    }
    

   //Select an axis & set it's position
    Status = DeviceIoControl(
                             hDevice,
                             (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                       //don't expect a response
                             "av lp6000;",                //Command string
                             (DWORD)128,               //Max length of string
                             &CommandCharsSent,        //Returns count of
                                                       // command chars sent
                             (DWORD)1,                 //...
                             &BytesReturned,          
                              NULL);                   //Synchronous Operations

    //If the controller did not accept all of the command string
    //with in two seconds clean up and exit the thread
    if(CommandCharsSent != 10)
    {
      printf("Thread 6 lp0 command timed out\n");
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
    //Give the controller some time to execute the previous command
    Sleep(100L);  
      
                                
                              
    //Send an axis position query to oms1 and wait for the response
    Status = DeviceIoControl(
                             hDevice,               //CreateFile Device handle
                             (DWORD)IOCTL_OMS_QUERY,//Send command get response
                             "av rp;",              //Command string to send
                             (DWORD)128,            //Maximum length of command
                             (LPVOID)ResponseString,//Controller response here
                             (DWORD)128,            //Maximum length response
                             &BytesReturned,        //Actual length of response
                                                    //including the null.
                              NULL);                //Synchronous Operations 
                              
    //If the controller returned the axis position with in 2 seconds                          
    if(ResponseString[0] != (UCHAR)NULL)
    {
      printf("Start Position V = %s \n", ResponseString);
    }
    else //handle the controller's response time out
    {
      printf("***Thread 6 position query time out \n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 6 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
                              
    //Command the axis to make 200 separate moves                          
    for (i=0; i<200; i++)
    {
      //Make sure the driver's copy of the axis done flag is clear                          
      DoneMask = 0x20;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                              
      //Send a move command:
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                         //don't expect a response
                               "av mr1000;gd id",  //Command string
                               (DWORD)128,               //Max length of string
                               &CommandCharsSent,  //Returns cmd length
                               (DWORD)1,                  //...
                               &BytesReturned,          
                                NULL);                   //Synchronous Operations
    
      //If controller did not accept all of the command string with in 2
      // seconds then clean up and exit the thread
      if(CommandCharsSent != 15)
      {
        printf(" Thread 6 Command chars sent = %d \n",CommandCharsSent);
        printf(" Thread 6 mr1000... timed out\n");
        CloseHandle (hDevice);
        ExitThread(1);   
      }    
      
                              
      //Wait until the axis move is complete
      DoneFlags = 0;
      while ((DoneFlags & 0x20) != 0x20)
      {                          
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_DONE,//Read the driver's 
                                                            //copy of the done flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &DoneFlags,                //Done flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
      }                          
    
      //Clear the axis done bit in the drivers copy of the done flags                          
      DoneMask = 0x20;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                                
      //Get the current position of the axis
      //Send the command string "RP" to oms1 and wait for the response
      Status = DeviceIoControl(
                               hDevice,               //CreateFile Device handle
                               (DWORD)IOCTL_OMS_QUERY,//Send command get response
                               "av rp",                  //Command string to send
                               (DWORD)128,            //Maximum length of command
                               (LPVOID)ResponseString,//Controller response here
                               (DWORD)128,            //Maximum length response
                               &BytesReturned,        //Actual length of response
                                                      //including the null.
                                NULL);                //Synchronous Operations 
                                
                                
      if(ResponseString[0] == (UCHAR)NULL)
      {
        printf("***Thread 6 response time out \n");
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                              //copy of the status flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &StatusFlags,              //Status flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
        //Make sure the driver's copy of status flags are clear                          
        FlagMask = 0xff;
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                                 &FlagMask,                 //Flags selected by ones
                                 (DWORD) 1,                 //Mask is one byte
                                 (LPVOID)NULL,              //No response expected
                                 (DWORD) 0,                 //...
                                 &BytesReturned,            //Not used but required
                                  NULL);                    //Synchronous Operations
        printf("Thread 6 status flags = %0x \n", StatusFlags);                        
        printf("%d - V = %s \n", (i+1), ResponseString);
        CloseHandle (hDevice);
        ExitThread(0);   
      }    
                              
    }             

    printf("End Position V = %s \n", ResponseString);
    printf("Thread 6 done \n");
    //Wait 1 second for printf to complete 
    Sleep(1000L);
    
    //Close the motor controller's device handle
    CloseHandle (hDevice);
    
    
   
}


//Thread to:
// - move the R axis 200 times
// - wait for each move to complete
// - report the axis position after each move
DWORD Thread7(DWORD dwThreadArg)
{  

    HANDLE   hDevice;
    BOOLEAN  Status;
    char     ResponseString[128];
    DWORD    BytesReturned;
    UCHAR    DoneFlags;
    UCHAR    DoneMask;
    UCHAR    StatusFlags;
    UCHAR    FlagMask;
    UCHAR    CommandCharsSent;
    int      Fields;
    int      Controller;
    int      i;
    DWORD    MStatus;

     //Get a handle to the motor controller's device driver OMS...
    hDevice = CreateFile ("\\\\.\\OMS1",
                          GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ | FILE_SHARE_WRITE,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL
                          );

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf ("Thread 7 Can't get a handle to \\\\.\\OMS1\n" );
        ExitThread(1);   
    }
    else
    {
        printf ("Thread 7 Start\n");
    }
    

   //Select an axis & set it's position
    Status = DeviceIoControl(
                             hDevice,
                             (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                       //don't expect a response
                             "ar lp7000;",                //Command string
                             (DWORD)128,               //Max length of string
                             &CommandCharsSent,        //Returns count of
                                                       // command chars sent
                             (DWORD)1,                 //...
                             &BytesReturned,          
                              NULL);                   //Synchronous Operations

    //If the controller did not accept all of the command string
    //with in two seconds clean up and exit the thread
    if(CommandCharsSent != 10)
    {
      printf("Thread 7 lp0 command timed out\n");
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
    //Give the controller some time to execute the previous command
    Sleep(100L);  
      
                                
                              
    //Send an axis position query to oms1 and wait for the response
    Status = DeviceIoControl(
                             hDevice,               //CreateFile Device handle
                             (DWORD)IOCTL_OMS_QUERY,//Send command get response
                             "ar rp;",              //Command string to send
                             (DWORD)128,            //Maximum length of command
                             (LPVOID)ResponseString,//Controller response here
                             (DWORD)128,            //Maximum length response
                             &BytesReturned,        //Actual length of response
                                                    //including the null.
                              NULL);                //Synchronous Operations 
                              
    //If the controller returned the axis position with in 2 seconds                          
    if(ResponseString[0] != (UCHAR)NULL)
    {
      printf("Start Position R = %s \n", ResponseString);
    }
    else //handle the controller's response time out
    {
      printf("***Thread 7 position query time out \n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 7 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
                              
    //Command the axis to make 200 separate moves                          
    for (i=0; i<200; i++)
    {
      //Make sure the driver's copy of the axis done flag is clear                          
      DoneMask = 0x40;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                              
      //Send a move command:
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                         //don't expect a response
                               "ar mr1000;gd id",  //Command string
                               (DWORD)128,               //Max length of string
                               &CommandCharsSent,  //Returns cmd length
                               (DWORD)1,                  //...
                               &BytesReturned,          
                                NULL);                   //Synchronous Operations
    
      //If controller did not accept all of the command string with in 2
      // seconds then clean up and exit the thread
      if(CommandCharsSent != 15)
      {
        printf(" Thread 7 Command chars sent = %d \n",CommandCharsSent);
        printf(" Thread 7 mr1000... timed out\n");
        CloseHandle (hDevice);
        ExitThread(1);   
      }    
      
                              
      //Wait until the axis move is complete
      DoneFlags = 0;
      while ((DoneFlags & 0x40) != 0x40)
      {                          
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_DONE,//Read the driver's 
                                                            //copy of the done flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &DoneFlags,                //Done flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
      }                          
    
      //Clear the axis done bit in the drivers copy of the done flags                          
      DoneMask = 0x40;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                                
      //Get the current position of the axis
      //Send the command string "RP" to oms1 and wait for the response
      Status = DeviceIoControl(
                               hDevice,               //CreateFile Device handle
                               (DWORD)IOCTL_OMS_QUERY,//Send command get response
                               "ar rp",                  //Command string to send
                               (DWORD)128,            //Maximum length of command
                               (LPVOID)ResponseString,//Controller response here
                               (DWORD)128,            //Maximum length response
                               &BytesReturned,        //Actual length of response
                                                      //including the null.
                                NULL);                //Synchronous Operations 
                                
                                
      if(ResponseString[0] == (UCHAR)NULL)
      {
        printf("***Thread 7 response time out \n");
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                              //copy of the status flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &StatusFlags,              //Status flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
        //Make sure the driver's copy of status flags are clear                          
        FlagMask = 0xff;
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                                 &FlagMask,                 //Flags selected by ones
                                 (DWORD) 1,                 //Mask is one byte
                                 (LPVOID)NULL,              //No response expected
                                 (DWORD) 0,                 //...
                                 &BytesReturned,            //Not used but required
                                  NULL);                    //Synchronous Operations
        printf("Thread 7 status flags = %0x \n", StatusFlags);                        
        printf("%d - R = %s \n", (i+1), ResponseString);
        CloseHandle (hDevice);
        ExitThread(0);   
      }    
                              
    }             

    printf("End Position R = %s \n", ResponseString);
    printf("Thread 7 done \n");
    //Wait 1 second for printf to complete 
    Sleep(1000L);
    
    //Close the motor controller's device handle
    CloseHandle (hDevice);
    
    
   
}


//Thread to:
// - move the S axis 200 times
// - wait for each move to complete
// - report the axis position after each move
DWORD Thread8(DWORD dwThreadArg)
{  

    HANDLE   hDevice;
    BOOLEAN  Status;
    char     ResponseString[128];
    DWORD    BytesReturned;
    UCHAR    DoneFlags;
    UCHAR    DoneMask;
    UCHAR    StatusFlags;
    UCHAR    FlagMask;
    UCHAR    CommandCharsSent;
    int      Fields;
    int      Controller;
    int      i;
    DWORD    MStatus;

     //Get a handle to the motor controller's device driver OMS...
    hDevice = CreateFile ("\\\\.\\OMS1",
                          GENERIC_READ | GENERIC_WRITE,
                          FILE_SHARE_READ | FILE_SHARE_WRITE,
                          NULL,
                          OPEN_EXISTING,
                          FILE_ATTRIBUTE_NORMAL,
                          NULL
                          );

    if (hDevice == INVALID_HANDLE_VALUE)
    {
        printf ("Thread 8 Can't get a handle to \\\\.\\OMS1\n" );
        ExitThread(1);   
    }
    else
    {
        printf ("Thread 8 Start\n");
    }
    

   //Select an axis & set it's position
    Status = DeviceIoControl(
                             hDevice,
                             (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                       //don't expect a response
                             "as lp8000;",                //Command string
                             (DWORD)128,               //Max length of string
                             &CommandCharsSent,        //Returns count of
                                                       // command chars sent
                             (DWORD)1,                 //...
                             &BytesReturned,          
                              NULL);                   //Synchronous Operations

    //If the controller did not accept all of the command string
    //with in two seconds clean up and exit the thread
    if(CommandCharsSent != 10)
    {
      printf("Thread 8 lp0 command timed out\n");
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
    //Give the controller some time to execute the previous command
    Sleep(100L);  
      
                                
                              
    //Send an axis position query to oms1 and wait for the response
    Status = DeviceIoControl(
                             hDevice,               //CreateFile Device handle
                             (DWORD)IOCTL_OMS_QUERY,//Send command get response
                             "as rp;",              //Command string to send
                             (DWORD)128,            //Maximum length of command
                             (LPVOID)ResponseString,//Controller response here
                             (DWORD)128,            //Maximum length response
                             &BytesReturned,        //Actual length of response
                                                    //including the null.
                              NULL);                //Synchronous Operations 
                              
    //If the controller returned the axis position with in 2 seconds                          
    if(ResponseString[0] != (UCHAR)NULL)
    {
      printf("Start Position S = %s \n", ResponseString);
    }
    else //handle the controller's response time out
    {
      printf("***Thread 8 position query time out \n");
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                          //copy of the status flags
                               (LPVOID)NULL,              //Command string 
                               (DWORD) 0,                 //not sent
                               &StatusFlags,              //Status flags go here
                               (DWORD)1,                  //Flags require one byte
                               &BytesReturned,            //Bytes returned
                                NULL);                    //Synchronous Operations
      printf("Thread 8 status flags = %0x \n", StatusFlags);                        
      //Make sure the driver's copy of the controller status flags is clear
      FlagMask = 0xff;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                               &FlagMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
      CloseHandle (hDevice);
      ExitThread(1);   
    }    
                              
    //Command the axis to make 200 separate moves                          
    for (i=0; i<200; i++)
    {
      //Make sure the driver's copy of the axis done flag is clear                          
      DoneMask = 0x80;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                              
      //Send a move command:
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_COMMAND, //Send commmand string
                                                         //don't expect a response
                               "as mr1000;gd id",  //Command string
                               (DWORD)128,               //Max length of string
                               &CommandCharsSent,  //Returns cmd length
                               (DWORD)1,                  //...
                               &BytesReturned,          
                                NULL);                   //Synchronous Operations
    
      //If controller did not accept all of the command string with in 2
      // seconds then clean up and exit the thread
      if(CommandCharsSent != 15)
      {
        printf(" Thread 8 Command chars sent = %d \n",CommandCharsSent);
        printf(" Thread 8 mr1000... timed out\n");
        CloseHandle (hDevice);
        ExitThread(1);   
      }    
      
                              
      //Wait until the axis move is complete
      DoneFlags = 0;
      while ((DoneFlags & 0x80) != 0x80)
      {                          
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_DONE,//Read the driver's 
                                                            //copy of the done flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &DoneFlags,                //Done flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
      }                          
    
      //Clear the axis done bit in the drivers copy of the done flags                          
      DoneMask = 0x80;
      Status = DeviceIoControl(
                               hDevice,
                               (DWORD)IOCTL_OMS_CLR_DONE, //Clear selected done flags
                               &DoneMask,                 //Flags selected by ones
                               (DWORD) 1,                 //Mask is one byte
                               (LPVOID)NULL,              //No response expected
                               (DWORD) 0,                 //...
                               &BytesReturned,            //Not used but required
                                NULL);                    //Synchronous Operations
                                
      //Get the current position of the axis
      //Send the command string "RP" to oms1 and wait for the response
      Status = DeviceIoControl(
                               hDevice,               //CreateFile Device handle
                               (DWORD)IOCTL_OMS_QUERY,//Send command get response
                               "as rp",                  //Command string to send
                               (DWORD)128,            //Maximum length of command
                               (LPVOID)ResponseString,//Controller response here
                               (DWORD)128,            //Maximum length response
                               &BytesReturned,        //Actual length of response
                                                      //including the null.
                                NULL);                //Synchronous Operations 
                                
                                
      if(ResponseString[0] == (UCHAR)NULL)
      {
        printf("***Thread 8 response time out \n");
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_READ_STATUS,//Read the driver's 
                                                              //copy of the status flags
                                 (LPVOID)NULL,              //Command string 
                                 (DWORD) 0,                 //not sent
                                 &StatusFlags,              //Status flags go here
                                 (DWORD)1,                  //Flags require one byte
                                 &BytesReturned,            //Bytes returned
                                  NULL);                    //Synchronous Operations
        //Make sure the driver's copy of status flags are clear                          
        FlagMask = 0xff;
        Status = DeviceIoControl(
                                 hDevice,
                                 (DWORD)IOCTL_OMS_CLR_STATUS, //Clear selected done flags
                                 &FlagMask,                 //Flags selected by ones
                                 (DWORD) 1,                 //Mask is one byte
                                 (LPVOID)NULL,              //No response expected
                                 (DWORD) 0,                 //...
                                 &BytesReturned,            //Not used but required
                                  NULL);                    //Synchronous Operations
        printf("Thread 8 status flags = %0x \n", StatusFlags);                        
        printf("%d - S = %s \n", (i+1), ResponseString);
        CloseHandle (hDevice);
        ExitThread(0);   
      }    
                              
    }             

    printf("End Position S = %s \n", ResponseString);
    printf("Thread 8 done \n");
    //Wait 1 second for printf to complete 
    Sleep(1000L);
    
    //Close the motor controller's device handle
    CloseHandle (hDevice);
    
    
}


